<template>
    <div>
        <h3>List of client bookings</h3>
        <template v-if="bookings && bookings.length > 0">
            <select v-model="bookingFilter" @change="getBookings">
                <option
                    v-for="(option, index) in bookingOptions"
                    :key="index"
                    :value="option.value"
                >
                    {{ option.label }}
                </option>
            </select>
            <table>
                <thead>
                    <tr>
                        <th>Time</th>
                        <th>Notes</th>
                        <th>Actions</th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="booking in bookings" :key="booking.id">
                        <td>{{ booking.start }} - {{ booking.end }}</td>
                        <td>{{ booking.notes }}</td>
                        <td>
                            <button
                                class="btn btn-danger btn-sm"
                                @click="deleteBooking(booking)"
                            >
                                Delete
                            </button>
                        </td>
                    </tr>
                </tbody>
            </table>
        </template>

        <template v-else>
            <p class="text-center">The client has no bookings.</p>
        </template>
    </div>
</template>

<script>
export default {
    name: 'BookingShow',
    props: {
        clientId: {
            required: true,
        },
    },
    data() {
        return {
            bookings: [],
            bookingOptions: [
                { label: 'All bookings', value: 'all' },
                { label: 'Future bookings only', value: 'future' },
                { label: 'Past bookings only', value: 'past' },
            ],
            bookingFilter: 'all',
        };
    },
    created() {
        this.getBookings();
    },
    methods: {
        getBookings() {
            axios
                .get(
                    `/clients/${this.clientId}/bookings/?bookings=${this.bookingFilter}`
                )
                .then((response) => {
                    this.bookings = response.data;
                });
        },
        deleteBooking(booking) {
            axios
                .delete(`/clients/${this.clientId}/bookings/${booking.id}`)
                .then(() => {
                    const bookingId = this.bookings.findIndex(
                        (item) => item.id === booking.id
                    );
                    this.bookings.splice(bookingId, 1);
                });
        },
    },
};
</script>
